// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "util/UsageLock.hpp"

using namespace Dawn;

UsageLock::UsageLock() {
  this->onEmpty = []() {};
  this->onFirstLock = []() {};
}

usagelockid_t UsageLock::createLock() {
  usagelockid_t lock = this->nextLock++;
  this->locks.push_back(lock);
  if(this->locks.size() == 1) this->onFirstLock();
  return lock;
}

void UsageLock::removeLock(usagelockid_t lock) {
  auto it = std::find(this->locks.begin(), this->locks.end(), lock);
  if(it == this->locks.end()) return;
  this->locks.erase(it);
  if(this->locks.size() == 0) this->onEmpty();
}